package net.ihe.gazelle.proxy.dao;

import java.util.Date;
import java.util.List;

import javax.persistence.EntityManager;

import net.ihe.gazelle.proxy.model.tm.Step;
import net.ihe.gazelle.proxy.util.HibernateUtilProxy;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;

public class ProxyDAOTM {

	public static void updateStepDate(int testStepId) {
		EntityManager entityManager = HibernateUtilProxy.buildEntityManager();
		List<Step> steps = getStepsByTMId(testStepId, entityManager);
		for (Step step : steps) {
			step.setDate(new Date());
			entityManager.merge(step);
		}
		HibernateUtilProxy.releaseEntityManager(entityManager);
	}

	public static List<Step> getStepsByTMId(int testStepId, EntityManager entityManager) {
		Session session = HibernateUtilProxy.getSession(entityManager);
		Criteria criteria = session.createCriteria(Step.class);
		criteria.add(Restrictions.eq("tmId", new Integer(testStepId)));
		List<Step> steps = criteria.list();
		return steps;
	}

}
