/*
 * Copyright 2010 IHE International (http://www.ihe.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.ihe.gazelle.proxy.model;

import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.hibernate.validator.NotNull;

/**
 * 
 * 
 * @class Channel.java
 * @package net.ihe.gazelle.systems.model
 * @author Jean-Baptiste Meyer / INRIA Rennes IHE development Project
 * @see > jmeyer@irisa.fr - http://www.ihe-europe.org
 * @version 1.0 - 2009, November 20
 * 
 */

@Entity
@Table(name = "pxy_dicom_uid_values", schema = "public")
@SequenceGenerator(name = "pxy_dicom_uid_values_sequence", sequenceName = "pxy_dicom_uid_values_id_seq", allocationSize = 1)
public class DicomUIDValues extends LabelKeywordDescriptionClass implements java.io.Serializable {

	/** Serial ID version of this object */
	private static final long serialVersionUID = 54153497124922L;

	// Attributes (existing in database as a column)
	@Id
	@Column(name = "id", unique = true, nullable = false)
	@NotNull
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "pxy_dicom_uid_values_sequence")
	private Integer id;

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public DicomUIDValues() {
		super();
		// TODO Auto-generated constructor stub
	}

	public DicomUIDValues(LabelKeywordDescriptionClass inLabelKeywordDescriptionClass) {
		super(inLabelKeywordDescriptionClass);
		// TODO Auto-generated constructor stub
	}

	@SuppressWarnings("unchecked")
	public static List<DicomUIDValues> getDicomUIDValuesList(EntityManager em) {
		return (List<DicomUIDValues>) getListStatus(DicomUIDValues.class, em);
	}

}
