package org.gazelle.proxy.loadtests;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.ThreadPoolExecutor;

public class App {

	public static void main(String[] args) throws InterruptedException, ExecutionException {
		ThreadPoolExecutor threadPool = (ThreadPoolExecutor) Executors.newFixedThreadPool(12);

		List<Future<String>> futures = new ArrayList<Future<String>>();

		for (int i = 0; i < 200; i++) {
			final int j = i;
			Callable<String> task = new Callable<String>() {
				@Override
				public String call() throws Exception {
					System.out.println("Called " + j);

					Thread.sleep(500 + Math.round(Math.random() * 500));

					System.out.println("Done " + j);
					return "toto" + j;
				}
			};
			Future<String> future = threadPool.submit(task);
			futures.add(future);
		}

		while (threadPool.getQueue().size() > 0) {
			Thread.sleep(1000);
		}

		boolean allFinished = false;
		while (!allFinished) {
			allFinished = true;
			for (Future<String> future : futures) {
				allFinished = allFinished && future.isDone();
			}
			if (!allFinished) {
				Thread.sleep(1000);
			}
		}

		for (Future<String> future : futures) {
			System.out.println(future.get());
		}

		threadPool.shutdown();
	}

}
