package net.ihe.gazelle.proxy.netty;

import java.util.ServiceLoader;

public enum ChannelType {

	DICOM("DicomMessage"),

	HL7("HL7Message"),

	SYSLOG("SyslogMessage"),

	HTTP("HTTPMessage"),

	RAW("RawMessage");

	private String discriminator;

	ChannelType(String discriminator) {
		this.discriminator = discriminator;
	}

	public String getDiscriminator() {
		return discriminator;
	}

	public Proxy<?, ?> getProxy(ConnectionConfig connectionConfig) {
		ServiceLoader<ProxyFactory> serviceLoader = ServiceLoader.load(ProxyFactory.class);
		for (ProxyFactory proxyFactory : serviceLoader) {
			if (proxyFactory.getChannelType().equals(this)) {
				return proxyFactory.newProxy(connectionConfig);
			}
		}
		return null;
	}

}
